#import "AppierFlutterPlugin.h"
#import <Appier/Appier.h>

@implementation AppierFlutterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"appier_flutter"
            binaryMessenger:[registrar messenger]];
  AppierFlutterPlugin* instance = [[AppierFlutterPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {

  if ([@"configure" isEqualToString:call.method]) {

    if (call.arguments && [call.arguments isKindOfClass:[NSDictionary class]]) {
      if ([call.arguments objectForKey:@"appId"] && [call.arguments objectForKey:@"isDev"]) {

         NSString *appId = [call.arguments objectForKey:@"appId"];
         NSString *senderId = [call.arguments objectForKey:@"senderId"];
         NSString *appGroup = [call.arguments objectForKey:@"appGroup"];
         bool isDev = [[call.arguments objectForKey:@"isDev"] boolValue];
         NSLog(@"appId:%@", appId);
         NSLog(@"senderId:%@", senderId);
         NSLog(@"isDev:%d", isDev);
         NSLog(@"appGroup:%@", appGroup);
         [[QGSdk getSharedInstance] onStart:appId withAppGroup:appGroup setDevProfile:isDev];
         result(nil);
         return;
       }
    }
    result(FlutterMethodNotImplemented);
  } else if ([@"logEvent" isEqualToString:call.method]) {

       NSDictionary *parameters = nil;
       if ([call.arguments objectForKey:@"parameters"]) {
         NSLog(@"parameters: %@", [call.arguments objectForKey:@"parameters"]);
         parameters = [call.arguments objectForKey:@"parameters"];
       }

       NSNumber *vts = [call.arguments objectForKey:@"vts"];
       NSLog(@"vtc class Name %@", NSStringFromClass([vts class]));

       NSNumber *vtsCurr = [call.arguments objectForKey:@"vtsCurr"];
       NSLog(@"vtsCurr class Name %@", NSStringFromClass([vtsCurr class]));

       if ([call.arguments objectForKey:@"eventName"]) {
         [[QGSdk getSharedInstance] logEvent:[call.arguments objectForKey:@"eventName"] withParameters:parameters withValueToSum:vts withValueToSumCurrency:vtsCurr];
       }

       result(nil);
  } else {
    result(FlutterMethodNotImplemented);
  }

}
@end
